/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef MEMORY_REGIONS_20060501_H_
#define MEMORY_REGIONS_20060501_H_

#include <QAbstractItemModel>
#include <QVector>
#include "Types.h"

#include "MemRegion.h"
#include "SymbolManager.h"

class MemoryRegions : public QAbstractItemModel {
	Q_OBJECT
public:
	virtual QVariant data(const QModelIndex &index, int role) const;
	virtual QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
	virtual QModelIndex parent(const QModelIndex &index) const;
	virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
	virtual int columnCount(const QModelIndex &parent = QModelIndex()) const;
	virtual QVariant headerData (int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
	
public:
	MemoryRegions(SymbolManager &sym);
	virtual ~MemoryRegions();
	
	void setPID(edb::pid_t pid);
	void clear();

	const QVector<MemRegion> &regions() const { return m_Regions; }
	
	void sync();
	
	bool findRegion(edb::address_t address, MemRegion &region) const;
	bool findRegion(edb::address_t address) const;

private:
	edb::pid_t			m_PID;
	QVector<MemRegion>	m_Regions;
	SymbolManager		&m_SymbolManager;
};

#endif
